diff --git a/web/pgadmin/feature_tests/pg_utilities_backup_restore_test.py b/web/pgadmin/feature_tests/pg_utilities_backup_restore_test.py
index 9afe007b5..0d4d8e9f6 100644
--- a/web/pgadmin/feature_tests/pg_utilities_backup_restore_test.py
+++ b/web/pgadmin/feature_tests/pg_utilities_backup_restore_test.py
@@ -11,9 +11,11 @@ import os
 from selenium.webdriver.support.ui import WebDriverWait
 from selenium.webdriver.common.by import By
 from selenium.webdriver.support import expected_conditions as EC
+from selenium.common.exceptions import ElementClickInterceptedException
 from regression.feature_utils.base_feature_test import BaseFeatureTest
 from regression.python_test_utils import test_utils
 from regression.python_test_utils import test_gui_helper
+from regression.feature_utils.locators import NavMenuLocators
 
 
 class PGUtilitiesBackupFeatureTest(BaseFeatureTest):
@@ -61,22 +63,47 @@ class PGUtilitiesBackupFeatureTest(BaseFeatureTest):
         self.page.toggle_open_tree_item(self.database_name)
 
         # Backup
-        self.driver.find_element_by_link_text("Tools").click()
-
-        self.page.find_by_partial_link_text("Backup...").click()
-
-        self.wait.until(EC.element_to_be_clickable(
-            (By.CSS_SELECTOR, ".file [name='file']")))
-
-        self.wait.until(EC.element_to_be_clickable(
-            (By.CSS_SELECTOR, ".file [name='file']"))).click()
+        retry = 3
+        while retry > 0:
+            try:
+                self.driver.find_element_by_link_text(
+                    NavMenuLocators.tools_menu_link_text).click()
+                break
+            except ElementClickInterceptedException:
+                retry -= 1
+
+        backup_object = self.wait.until(EC.visibility_of_element_located(
+            (By.CSS_SELECTOR, NavMenuLocators.backup_obj_css)))
+        backup_object.click()
+
+        # Enter the file name of the backup to be taken
+        self.wait.until(EC.visibility_of_element_located(
+            (By.NAME, NavMenuLocators.backup_filename_txt_box_name)))
+        element = self.wait.until(EC.element_to_be_clickable(
+            (By.NAME, NavMenuLocators.backup_filename_txt_box_name)))
+        element.click()
         self.page.fill_input_by_field_name(
-            "file", "test_backup", loose_focus=True)
-
-        self.page.find_by_xpath("//button[contains(@class,'fa-save') "
-                                "and contains(.,'Backup')]").click()
-
-        self.page.find_by_css_selector('.ajs-bg-bgprocess')
+            NavMenuLocators.backup_filename_txt_box_name,
+            "test_backup", loose_focus=True)
+
+        # Click on the take Backup button
+        take_bckup = self.page.find_by_xpath(
+            NavMenuLocators.backup_btn_xpath)
+        click = True
+        while click:
+            try:
+                take_bckup.click()
+                if self.page.wait_for_element_to_disappear(
+                    lambda driver: driver.find_element_by_name(
+                        NavMenuLocators.backup_filename_txt_box_name)):
+                    click = False
+            except Exception as e:
+                pass
+
+        # Wait for the backup status alertfier
+        self.wait.until(EC.visibility_of_element_located(
+            (By.CSS_SELECTOR,
+             NavMenuLocators.bcg_process_status_alertifier_css)))
 
         status = test_utils.get_watcher_dialogue_status(self)
 
@@ -86,7 +113,10 @@ class PGUtilitiesBackupFeatureTest(BaseFeatureTest):
         self.assertEquals(status, "Successfully completed.")
 
         self.page.find_by_css_selector(
-            ".pg-bg-more-details").click()
+            NavMenuLocators.status_alertifier_more_btn_css).click()
+
+        self.wait.until(EC.visibility_of_element_located(
+            (By.XPATH, NavMenuLocators.process_watcher_alertfier)))
 
         backup_file = None
         # Check for XSS in Backup details
@@ -94,7 +124,8 @@ class PGUtilitiesBackupFeatureTest(BaseFeatureTest):
             self._check_detailed_window_for_xss('Backup')
         else:
             command = self.page.find_by_css_selector(
-                ".bg-process-details .bg-detailed-desc").text
+                NavMenuLocators.process_watcher_detailed_command_canvas_css).\
+                text
 
             self.assertIn(self.server['name'], str(command))
             self.assertIn("from database 'pg_utility_test_db'", str(command))
@@ -109,26 +140,41 @@ class PGUtilitiesBackupFeatureTest(BaseFeatureTest):
                 backup_file = command[int(command.find('--file')) +
                                       8:int(command.find('--host')) - 2]
 
-        self.page.find_by_xpath("//div[contains(@class,'wcFloatingFocus')"
-                                "]//div[contains(@class,'fa-close')]").click()
+        close_btn = self.page.find_by_xpath(
+            NavMenuLocators.process_watcher_close_button_xpath)
+        close_btn.click()
 
         # Restore
-        self.driver.find_element_by_link_text("Tools").click()
-        self.page.find_by_partial_link_text("Restore...").click()
+        tools_menu = self.driver.find_element_by_link_text(
+            NavMenuLocators.tools_menu_link_text)
+        tools_menu.click()
 
-        self.wait.until(EC.element_to_be_clickable(
-            (By.CSS_SELECTOR, ".file [name='file']")))
+        restore_obj = self.page.find_by_css_selector(
+            NavMenuLocators.restore_obj_css)
+        restore_obj.click()
+
+        self.wait.until(EC.visibility_of_element_located(
+            (By.NAME, NavMenuLocators.restore_file_name_txt_box_name)))
 
         self.wait.until(EC.element_to_be_clickable(
-            (By.CSS_SELECTOR, ".file [name='file']"))).click()
+            (By.NAME, NavMenuLocators.restore_file_name_txt_box_name))).click()
 
         self.page.fill_input_by_field_name(
-            "file", "test_backup", loose_focus=True)
+            NavMenuLocators.restore_file_name_txt_box_name,
+            "test_backup", loose_focus=True)
+
+        restore_btn = self.page.find_by_xpath(
+            NavMenuLocators.restore_button_xpath)
+        restore_btn.click()
 
-        self.page.find_by_xpath("//button[contains(@class,'fa-upload')"
-                                " and contains(.,'Restore')]").click()
+        self.page.wait_for_element_to_disappear(
+            lambda driver: driver.find_element_by_css_selector(
+                NavMenuLocators.restore_file_name_txt_box_name))
 
-        self.page.find_by_css_selector('.ajs-bg-bgprocess')
+        # Wait for the backup status alertfier
+        self.wait.until(EC.visibility_of_element_located(
+            (By.CSS_SELECTOR,
+             NavMenuLocators.bcg_process_status_alertifier_css)))
 
         status = test_utils.get_watcher_dialogue_status(self)
 
@@ -138,14 +184,18 @@ class PGUtilitiesBackupFeatureTest(BaseFeatureTest):
         self.assertEquals(status, "Successfully completed.")
 
         self.page.find_by_css_selector(
-            ".pg-bg-more-details").click()
+            NavMenuLocators.status_alertifier_more_btn_css).click()
+
+        self.wait.until(EC.visibility_of_element_located(
+            (By.XPATH, NavMenuLocators.process_watcher_alertfier)))
 
         # Check for XSS in Restore details
         if self.is_xss_check:
             self._check_detailed_window_for_xss('Restore')
         else:
             command = self.page.find_by_css_selector(
-                ".bg-process-details .bg-detailed-desc").text
+                NavMenuLocators.process_watcher_detailed_command_canvas_css).\
+                text
 
             self.assertIn(self.server['name'], str(command))
             if os.name is not 'nt':
@@ -153,8 +203,9 @@ class PGUtilitiesBackupFeatureTest(BaseFeatureTest):
 
             self.assertIn("pg_restore", str(command))
 
-        self.page.find_by_xpath("//div[contains(@class,'wcFloatingFocus')]"
-                                "//div[contains(@class,'fa-close')]").click()
+        close_watcher = self.page.find_by_xpath(
+            NavMenuLocators.process_watcher_close_button_xpath)
+        close_watcher.click()
 
         if backup_file is not None:
             if os.path.isfile(backup_file):
@@ -175,7 +226,7 @@ class PGUtilitiesBackupFeatureTest(BaseFeatureTest):
 
     def _check_detailed_window_for_xss(self, tool_name):
         source_code = self.page.find_by_css_selector(
-            ".bg-process-details .bg-detailed-desc"
+            NavMenuLocators.process_watcher_detailed_command_canvas_css
         ).get_attribute('innerHTML')
         self._check_escaped_characters(
             source_code,
diff --git a/web/pgadmin/feature_tests/pg_utilities_maintenance_test.py b/web/pgadmin/feature_tests/pg_utilities_maintenance_test.py
index 129f63478..7524f141d 100644
--- a/web/pgadmin/feature_tests/pg_utilities_maintenance_test.py
+++ b/web/pgadmin/feature_tests/pg_utilities_maintenance_test.py
@@ -6,13 +6,15 @@
 # This software is released under the PostgreSQL Licence
 #
 ##########################################################################
-
-import time
-
 from selenium.webdriver.support.ui import WebDriverWait
+from selenium.webdriver.support import expected_conditions as EC
+from selenium.webdriver.common.by import By
+from selenium.common.exceptions import ElementClickInterceptedException
 from regression.feature_utils.base_feature_test import BaseFeatureTest
 from regression.python_test_utils import test_utils
 from regression.python_test_utils import test_gui_helper
+from regression.feature_utils.locators import NavMenuLocators
+import random
 
 
 class PGUtilitiesMaintenanceFeatureTest(BaseFeatureTest):
@@ -55,6 +57,8 @@ class PGUtilitiesMaintenanceFeatureTest(BaseFeatureTest):
             self.server['port'],
             self.server['sslmode']
         )
+
+        self.table_name = self.table_name + str(random.randint(1000, 3000))
         test_utils.drop_database(connection, self.database_name)
         test_utils.create_database(self.server, self.database_name)
         test_utils.create_table(self.server, self.database_name,
@@ -66,8 +70,16 @@ class PGUtilitiesMaintenanceFeatureTest(BaseFeatureTest):
     def runTest(self):
         self._open_maintenance_dialogue()
         self.page.click_modal('OK')
-        self.page.find_by_css_selector('.ajs-bg-bgprocess')
-        self._verify_command()
+        self.page.wait_for_element_to_disappear(
+            lambda driver: driver.find_element_by_xpath(
+                NavMenuLocators.maintenance_operation))
+
+        # Wait for the backup status alertfier
+        self.wait.until(EC.visibility_of_element_located(
+            (By.CSS_SELECTOR,
+             NavMenuLocators.bcg_process_status_alertifier_css)))
+
+        self.verify_command()
 
     def _open_maintenance_dialogue(self):
         self.page.toggle_open_server(self.server['name'])
@@ -78,30 +90,49 @@ class PGUtilitiesMaintenanceFeatureTest(BaseFeatureTest):
             self.page.toggle_open_tree_item('public')
             self.page.toggle_open_tables_node()
             self.page.select_tree_item(self.table_name)
+        retry = 3
+        while retry > 0:
+            try:
+                tools_menu = self.driver.find_element_by_link_text(
+                    NavMenuLocators.tools_menu_link_text)
+                tools_menu.click()
+                break
+            except ElementClickInterceptedException:
+                retry -= 1
+        maintenance_obj = self.wait.until(EC.visibility_of_element_located(
+            (By.CSS_SELECTOR, NavMenuLocators.maintenance_obj_css)))
+        maintenance_obj.click()
 
-        self.driver.find_element_by_link_text("Tools").click()
-        self.page.find_by_partial_link_text("Maintenance...").click()
-        time.sleep(0.5)
+        self.page.check_if_element_exist_by_xpath(
+            NavMenuLocators.maintenance_operation, 10)
 
-    def _verify_command(self):
+    def verify_command(self):
         status = test_utils.get_watcher_dialogue_status(self)
         if status != "Successfully completed.":
+
             test_gui_helper.close_bgprocess_popup(self)
 
         self.assertEquals(status, "Successfully completed.")
-        self.page.find_by_css_selector(".pg-bg-more-details").click()
+        self.page.find_by_css_selector(
+            NavMenuLocators.status_alertifier_more_btn_css).click()
+
+        self.wait.until(EC.visibility_of_element_located(
+            (By.XPATH, NavMenuLocators.process_watcher_alertfier)))
+
         command = self.page.find_by_css_selector(
-            ".bg-process-details .bg-detailed-desc").text
+            NavMenuLocators.
+            process_watcher_detailed_command_canvas_css).text
+
         if self.test_level == 'database':
-            self.assertEquals(command, "VACUUM "
-                                       "(VERBOSE)\nRunning Query:"
+            self.assertEquals(command, "VACUUM (VERBOSE)\nRunning Query:"
                                        "\nVACUUM VERBOSE;")
         elif self.is_xss_check and self.test_level == 'table':
             # Check for XSS in the dialog
             source_code = self.page.find_by_css_selector(
-                ".bg-process-details .bg-detailed-desc"
+                NavMenuLocators.
+                process_watcher_detailed_command_canvas_css
             ).get_attribute('innerHTML')
-            self._check_escaped_characters(
+            self.check_escaped_characters(
                 source_code,
                 '&lt;h1&gt;test_me&lt;/h1&gt;',
                 'Maintenance detailed window'
@@ -112,12 +143,14 @@ class PGUtilitiesMaintenanceFeatureTest(BaseFeatureTest):
                                        "\nVACUUM VERBOSE"
                                        " public." + self.table_name + ";")
 
-        self.page.find_by_css_selector(
-            "div.wcFloatingFocus div.fa-close").click()
+        self.page.find_by_xpath(
+            NavMenuLocators.process_watcher_close_button_xpath).click()
 
     def after(self):
         test_gui_helper.close_bgprocess_popup(self)
         self.page.remove_server(self.server)
+        test_utils.delete_table(self.server, self.test_db,
+                                self.table_name)
         connection = test_utils.get_db_connection(
             self.server['db'],
             self.server['username'],
@@ -128,7 +161,7 @@ class PGUtilitiesMaintenanceFeatureTest(BaseFeatureTest):
         )
         test_utils.drop_database(connection, self.database_name)
 
-    def _check_escaped_characters(self, source_code, string_to_find, source):
+    def check_escaped_characters(self, source_code, string_to_find, source):
         # For XSS we need to search against element's html code
         assert source_code.find(string_to_find) != - \
             1, "{0} might be vulnerable to XSS ".format(source)
diff --git a/web/pgadmin/feature_tests/query_tool_auto_complete_tests.py b/web/pgadmin/feature_tests/query_tool_auto_complete_tests.py
index b36d23437..1f6e248ce 100644
--- a/web/pgadmin/feature_tests/query_tool_auto_complete_tests.py
+++ b/web/pgadmin/feature_tests/query_tool_auto_complete_tests.py
@@ -15,6 +15,7 @@ from selenium.webdriver import ActionChains
 from selenium.webdriver.common.keys import Keys
 from regression.python_test_utils import test_utils
 from regression.feature_utils.base_feature_test import BaseFeatureTest
+from regression.feature_utils.locators import QueryToolLocators
 
 
 class QueryToolAutoCompleteFeatureTest(BaseFeatureTest):
@@ -55,7 +56,10 @@ class QueryToolAutoCompleteFeatureTest(BaseFeatureTest):
         test_utils.create_table(self.server, self.test_db,
                                 self.second_table_name)
 
-        self._locate_database_tree_node()
+        self.page.toggle_open_tree_item(self.server['name'])
+        self.page.toggle_open_tree_item('Databases')
+        self.page.toggle_open_tree_item(self.test_db)
+
         self.page.open_query_tool()
         self.page.wait_for_spinner_to_disappear()
 
@@ -64,64 +68,64 @@ class QueryToolAutoCompleteFeatureTest(BaseFeatureTest):
         print("\nAuto complete ALTER keyword... ", file=sys.stderr, end="")
         self._auto_complete("A", "ALTER")
         print("OK.", file=sys.stderr)
-        self._clear_query_tool()
+        self.page.clear_query_tool()
 
         print("Auto complete BEGIN keyword... ", file=sys.stderr, end="")
         self._auto_complete("BE", "BEGIN")
         print("OK.", file=sys.stderr)
-        self._clear_query_tool()
+        self.page.clear_query_tool()
 
         print("Auto complete CASCADED keyword... ", file=sys.stderr, end="")
         self._auto_complete("CAS", "CASCADED")
         print("OK.", file=sys.stderr)
-        self._clear_query_tool()
+        self.page.clear_query_tool()
 
         print("Auto complete SELECT keyword... ", file=sys.stderr, end="")
         self._auto_complete("SE", "SELECT")
         print("OK.", file=sys.stderr)
-        self._clear_query_tool()
+        self.page.clear_query_tool()
 
         print("Auto complete pg_backend_pid() function ... ",
               file=sys.stderr, end="")
         self._auto_complete("SELECT pg_", "pg_backend_pid()")
         print("OK.", file=sys.stderr)
-        self._clear_query_tool()
+        self.page.clear_query_tool()
 
         print("Auto complete current_query() function ... ",
               file=sys.stderr, end="")
         self._auto_complete("SELECT current_", "current_query()")
         print("OK.", file=sys.stderr)
-        self._clear_query_tool()
+        self.page.clear_query_tool()
 
         print("Auto complete function with argument ... ",
               file=sys.stderr, end="")
         self._auto_complete("SELECT pg_st", "pg_stat_file(filename)")
         print("OK.", file=sys.stderr)
-        self._clear_query_tool()
+        self.page.clear_query_tool()
 
         print("Auto complete schema other than default start with test_ ... ",
               file=sys.stderr, end="")
         self._auto_complete("SELECT * FROM te", self.first_schema_name)
         print("OK.", file=sys.stderr)
-        self._clear_query_tool()
+        self.page.clear_query_tool()
 
         print("Auto complete schema other than default starts with comp_ ... ",
               file=sys.stderr, end="")
         self._auto_complete("SELECT * FROM co", self.second_schema_name)
         print("OK.", file=sys.stderr)
-        self._clear_query_tool()
+        self.page.clear_query_tool()
 
         print("Auto complete first table in public schema ... ",
               file=sys.stderr, end="")
         self._auto_complete("SELECT * FROM public.", self.first_table_name)
         print("OK.", file=sys.stderr)
-        self._clear_query_tool()
+        self.page.clear_query_tool()
 
         print("Auto complete second table in public schema ... ",
               file=sys.stderr, end="")
         self._auto_complete("SELECT * FROM public.", self.second_table_name)
         print("OK.", file=sys.stderr)
-        self._clear_query_tool()
+        self.page.clear_query_tool()
 
         print("Auto complete JOIN second table with after schema name ... ",
               file=sys.stderr, end="")
@@ -129,7 +133,7 @@ class QueryToolAutoCompleteFeatureTest(BaseFeatureTest):
                 " JOIN public."
         self._auto_complete(query, self.second_table_name)
         print("OK.", file=sys.stderr)
-        self._clear_query_tool()
+        self.page.clear_query_tool()
 
         print("Auto complete JOIN ON some columns ... ",
               file=sys.stderr, end="")
@@ -140,54 +144,51 @@ class QueryToolAutoCompleteFeatureTest(BaseFeatureTest):
                           ".some_column"
         self._auto_complete(query, expected_string)
         print("OK.", file=sys.stderr)
-        self._clear_query_tool()
+        self.page.clear_query_tool()
 
-        print("Auto complete JOIN ON some columns using tabel alias ... ",
+        print("Auto complete JOIN ON some columns using table alias ... ",
               file=sys.stderr, end="")
         query = "SELECT * FROM public." + self.first_table_name + \
                 " t1 JOIN public." + self.second_table_name + " t2 ON t2."
         self._auto_complete(query, "some_column = t1.some_column")
         print("OK.", file=sys.stderr)
-        self._clear_query_tool()
+        self.page.clear_query_tool()
 
     def after(self):
         self.page.remove_server(self.server)
-
-    def _locate_database_tree_node(self):
-        self.page.toggle_open_tree_item(self.server['name'])
-        self.page.toggle_open_tree_item('Databases')
-        self.page.toggle_open_tree_item(self.test_db)
-
-    def _clear_query_tool(self):
-        self.page.click_element(
-            self.page.find_by_xpath("//*[@id='btn-clear-dropdown']")
-        )
-        ActionChains(self.driver) \
-            .move_to_element(self.page.find_by_xpath("//*[@id='btn-clear']")) \
-            .perform()
-        self.page.click_element(
-            self.page.find_by_xpath("//*[@id='btn-clear']")
-        )
-        self.page.click_modal('Yes')
+        test_utils.delete_table(self.server, self.test_db,
+                                self.first_table_name)
+        test_utils.delete_table(self.server, self.test_db,
+                                self.second_table_name)
 
     def _auto_complete(self, word, expected_string):
         self.page.fill_codemirror_area_with(word)
-        ActionChains(self.page.driver).key_down(
-            Keys.CONTROL).send_keys(Keys.SPACE).key_up(Keys.CONTROL).perform()
-
-        # if IntelliSense is present then verify this
-        if self.page.check_if_element_exist_by_xpath(
-                "//ul[@class='CodeMirror-hints default']", 2):
+        hint_displayed = False
+        retry = 3
+        while retry > 0:
+            ActionChains(self.page.driver).key_down(
+                Keys.CONTROL).send_keys(Keys.SPACE).key_up(
+                Keys.CONTROL).perform()
+            if self.page.check_if_element_exist_by_xpath(
+                    QueryToolLocators.code_mirror_hint_box_xpath, 20):
+                hint_displayed = True
+                break
+            else:
+                retry -= 1
+        if hint_displayed:
+            # if IntelliSense is present then verify this
             self.page.find_by_xpath(
-                "//ul[contains(@class, 'CodeMirror-hints') and "
-                "contains(., '" + expected_string + "')]")
+                QueryToolLocators.code_mirror_hint_item_xpath.format(
+                    expected_string))
         else:
             # if no IntelliSense is present it means there is only one option
             #  so check if required string is present in codeMirror
-            code_mirror = self.page.find_by_xpath(
-                "//pre[@class=' CodeMirror-line ']/span")
-            code_mirror_text = code_mirror.text
-
-            if expected_string not in code_mirror_text:
-                raise Exception("Required String %s is not "
-                                "present" % expected_string)
+            code_mirror = self.driver.find_elements_by_xpath(
+                QueryToolLocators.code_mirror_data_xpath)
+            for data in code_mirror:
+                code_mirror_text = data.text
+                print("Single entry..........")
+                if expected_string not in code_mirror_text:
+                    print("single entry exception.........")
+                    raise Exception("Required String %s is not "
+                                    "present" % expected_string)
